/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.0 Professional
Automatic Program Generator
 Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 18.06.2015
Author  : 
Company : 
Comments: 


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>
#include <delay.h>
#include <stdio.h>

// Alphanumeric LCD Module functions
#include <alcd.h>

// LCD display buffer
char lcd_buffer[33];
#define DHT_DDR DDRD.7
#define DHT_OUT PORTD.7
#define DHT_IN  PIND.7
unsigned char data[5];

char GetHumidity()
{
    unsigned char n, k, idx;
    data[0] = data[1] = data[2] = data[3] = data[4] = 0;
    DHT_OUT = 0;
    delay_ms(18);
    DHT_OUT = 1;
    DHT_DDR = 0;
    delay_us(50);
    if(DHT_IN != 0)
    {
        return 1;
    }
    while(DHT_IN == 0)
    {
		//  -   
    }
    while(DHT_IN != 0)
    {
		//  -  
    }
    for(n = 0; n < 5; n++)
    {
        idx = 0x80;
        for(k = 0; k < 8; k++)
        {
            while(DHT_IN == 0)
            {
				//  -  
            }
            delay_us(33);
            if(DHT_IN != 0) data[n] |= idx;
            idx >>= 1;
            while(DHT_IN != 0)
            {
				//  -  
            }
        }
    }
	return 0;
}

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=0xFFFF
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=0xFF
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// USART initialization
// USART disabled
UCSRB=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC disabled
ADCSRA=0x00;

// SPI initialization
// SPI disabled
SPCR=0x00;

// TWI initialization
// TWI disabled
TWCR=0x00;

// Alphanumeric LCD initialization
// Connections specified in the
// Project|Configure|C Compiler|Libraries|Alphanumeric LCD menu:
// RS - PORTB Bit 0
// RD - PORTB Bit 1
// EN - PORTB Bit 2
// D4 - PORTB Bit 4
// D5 - PORTB Bit 5
// D6 - PORTB Bit 6
// D7 - PORTB Bit 7
// Characters/line: 16
lcd_init(16);
lcd_clear();
lcd_puts("Test");

while (1)
      {
      DHT_DDR = 1;
        DHT_OUT = 1;
        delay_ms(200);
        GetHumidity();
          //h = data[0] * 256 + data[1];
        //sprintf(lcd_buffer,"Hum = %d.%d",h/10,h%10); //DHT22
        sprintf(lcd_buffer,"Vlaznost' %d",data[0]); //DHT11
        lcd_clear();
        lcd_puts(lcd_buffer);
         //t = data[2] * 256 + data[3];
        //sprintf(lcd_buffer,"Temp = %d.%d",t/10,t%10); //DHT22
        sprintf(lcd_buffer,"Temperatyra %d",data[2]); //DHT11        
        lcd_gotoxy(0, 1);
        lcd_puts(lcd_buffer);

      }
}
